%V tomto programu jsou generovna jednorozmrn data z normlnho rozdlen, a je zkoumn vliv Masking a Swamping effectu 
%Na tvrtou verzi dat je aplikovn run implementovan Deanv - Dixonv test

fclose all; close all; clear all; clc;

NN = [3, 4, 5]; %vektor velikosti souboru
pocet_dat = size(NN,2);
pocet_simulaci = 1000; %pocet simulaci pro dan pocet outliers a velikost souboru
mu = 100;
sigma = 10;
Critical_values_5_percent = [0; 0; 0.941; 0.765; 0.642; 0.560; 0.507]; %viz Barnett

upper_outlier1=0;
upper_outlier2=0;
lower_outlier=0;
Dean_Dixon_procentni_vysledek = zeros(pocet_dat,4);

for j = 1:pocet_dat %pres vsechny pocty dat
    
           suma_prijmutiH1_1 = 0; %inicializace
           suma_prijmutiH1_2 = 0; %inicializace
           suma_prijmutiH1_3 = 0; %inicializace
           suma_prijmutiH1_4 = 0; %inicializace
                  
            for i = 1:pocet_simulaci
               norm_data = normrnd(mu,sigma,[1,NN(j)]); %data ridici se norm.r (pocet hodnot je promenlivy)
               maximum = max(norm_data);
               minimum = min(nonzeros(norm_data));
                      
            upper_outlier1=  maximum+4*sigma + rand*sigma; %generovani 1. upper outlier
            upper_outlier2=  maximum+4*sigma + rand*sigma; %generovani 2. upper outlier               
            lower_outlier = minimum-4*sigma - rand*sigma; %generovani 1. lower outlier
     
      data_obsahujici_outliers1 = [norm_data upper_outlier1];
      data_obsahujici_outliers2 = [norm_data upper_outlier1 upper_outlier2];
      data_obsahujici_outliers3 = [norm_data upper_outlier1 lower_outlier];
      data_neobsahujici_outliers4 = norm_data;

 if (i == 1)
    f = figure(j);
     subplot(2,2,1);
    hold on;
    plot(1:NN(j),sort(norm_data),'o','MarkerFaceColor', 'b');
    hold on;
    plot((NN(j)+1),upper_outlier1,'o', 'MarkerFaceColor', 'r');
    hold on;
yline(100);
yline(100+3*sigma);
yline(100-3*sigma);
yticks([50 100-3*sigma 100 100+3*sigma 150])
hold off; 
title("Poet upper outliers: 1");
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
 subplot(2,2,2);
    hold on;
    plot(1:NN(j),sort(norm_data),'o','MarkerFaceColor', 'b');
    hold on;
    plot((NN(j)+1),min(upper_outlier1,upper_outlier2),'o', 'MarkerFaceColor', 'r');
    plot((NN(j)+2),max(upper_outlier1,upper_outlier2),'o', 'MarkerFaceColor', 'r');
  hold on;
yline(100);
yline(100+3*sigma);
yline(100-3*sigma);
yticks([50 100-3*sigma 100 100+3*sigma 150])
hold off; 
title("Poet upper outliers: 2");
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
subplot(2,2,3);
    plot(1,lower_outlier,'o', 'MarkerFaceColor', 'r');
    hold on;
    plot(2:NN(j)+1,sort(norm_data),'o','MarkerFaceColor', 'b');
    hold on;
    plot(NN(j)+2,upper_outlier1,'o', 'MarkerFaceColor', 'r');
  hold on;
yline(100);
yline(100+3*sigma);
yline(100-3*sigma);
yticks([50 100-3*sigma 100 100+3*sigma 150])
hold off; 
title("Poet upper outliers: 1, poet lower outliers: 1");
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
subplot(2,2,4);
    plot(1:NN(j),sort(norm_data),'o','MarkerFaceColor', 'b');
    hold on;
yline(100);
yline(100+3*sigma);
yline(100-3*sigma);
yticks([50 100-3*sigma 100 100+3*sigma 150])
hold off; 
title("0 outliers");
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
sgtitle("Poet dat N=" + NN(j));
 end
clear upper_outlier1; clear lower_outlier; clear upper_outlier2;%aby se v i-t iteraci tvorila nova outliers

serazena_data1 = sort(data_obsahujici_outliers1);
serazena_data2 = sort(data_obsahujici_outliers2);
serazena_data3 = sort(data_obsahujici_outliers3);
serazena_data4 = sort(data_neobsahujici_outliers4);
%pocitani Dean Dixonova testu
T_1 = (max(data_obsahujici_outliers1) - serazena_data1(end-1))/(max(data_obsahujici_outliers1) - min(nonzeros(data_obsahujici_outliers1)));
n1 = nnz(data_obsahujici_outliers1); %=pocet dat celkem = n+ outliers
T_alfa_1 = Critical_values_5_percent(n1);

T_2 = (max(data_obsahujici_outliers2) - serazena_data2(end-1))/(max(data_obsahujici_outliers2) - min(nonzeros(data_obsahujici_outliers2)));
n2 = nnz(data_obsahujici_outliers2); %=pocet dat celkem = n+ outliers
T_alfa_2 = Critical_values_5_percent(n2);
T_3 = (max(data_obsahujici_outliers3) - serazena_data3(end-1))/(max(data_obsahujici_outliers3) - min(nonzeros(data_obsahujici_outliers3)));
n3 = nnz(data_obsahujici_outliers3); %=pocet dat celkem = n+ outliers
T_alfa_3 = Critical_values_5_percent(n3);

T_4 = (max(data_neobsahujici_outliers4) - serazena_data4(end-1))/(max(data_neobsahujici_outliers4) - min(nonzeros(data_neobsahujici_outliers4)));
n4 = nnz(data_neobsahujici_outliers4); %=pocet dat celkem = n+ outliers
T_alfa_4 = Critical_values_5_percent(n4);

if( T_1>T_alfa_1)  
    suma_prijmutiH1_1=suma_prijmutiH1_1+1;
end
if( T_2>T_alfa_2)  
    suma_prijmutiH1_2=suma_prijmutiH1_2+1;
end
if( T_3>T_alfa_3)  
    suma_prijmutiH1_3=suma_prijmutiH1_3+1;
end
if( T_4>T_alfa_4)  
    suma_prijmutiH1_4=suma_prijmutiH1_4+1;
end
        end
           
Dean_Dixon_procentni_vysledek(j,1) = suma_prijmutiH1_1/pocet_simulaci;
Dean_Dixon_procentni_vysledek(j,2) = suma_prijmutiH1_2/pocet_simulaci;
Dean_Dixon_procentni_vysledek(j,3) = suma_prijmutiH1_3/pocet_simulaci;
Dean_Dixon_procentni_vysledek(j,4) = suma_prijmutiH1_4/pocet_simulaci;
clear suma_prijmutiH1_1; clear suma_prijmutiH1_2; clear suma_prijmutiH1_3; clear suma_prijmutiH1_4;

end
   
vysledek = array2table(Dean_Dixon_procentni_vysledek, 'VariableNames',{'1 upper outlier','2 upper outliers','1 lower outlier, 1 upper outliers','0 outliers'},'RowNames',{'N=3','N=4','N=5'});
vysledek1 = table(vysledek,'VariableNames',{'spnost Dean-Dixonova (r10) testu pro detekci outliera xn'});
display(vysledek1)
