%V tomto programu jsou generovna jednorozmrn data z normlnho rozdlen,
%a je zkoumn vliv Masking a Swamping effectu 
%Na prvn a druhou verzi dat je aplikovan run implementovan metoda Grubbsova testu a metoda implementovan v Matlabu isoutlier(Grubbs);
%V tomto programu se zkoum poet dat N, pro kter je spnost testu 100%

fclose all; close all; clear all; clc
NN = [1:300]; %vektor velikosti souboru N
pocet_dat = size(NN,2);
outliers = [1,2,5,10]; %vektor poctu outliers (upper outliers)
rozmer_outliers = size(outliers,2);
pocet_simulaci = 1000; %pocet simulaci pro dan pocet outliers a velikost souboru
mu = 100;
sigma = 10;
alfa = 0.05;

upper_outliers=zeros(1,max(outliers));
lower_outlier = 0;
%tabulky pro 1 lower outliers + k upper outliers pro rzn poet n
Grubbs_procentni_vysledek_x1 = zeros(pocet_dat,rozmer_outliers);% n X (pocet outliers+1)
Grubbs_procentni_vysledek_xn = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_x1 = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_xn = zeros(pocet_dat,rozmer_outliers);
%tabulky pro k upper outliers pro rzn poet n
Grubbs_procentni_vysledek_x1_upper = zeros(pocet_dat,rozmer_outliers);% n X pocet outliers 
Grubbs_procentni_vysledek_xn_upper = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_x1_upper = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_xn_upper = zeros(pocet_dat,rozmer_outliers);

for j = 1:pocet_dat %pres vsechny pocty dat
    for o = 1:rozmer_outliers %pres vsechny pocty outliers
         suma_prijmutiH1_1 = 0; %inicializace
         suma_prijmutiH1_n = 0; %inicializace
         suma_prijmutiH1_1_matlab = 0; %inicializace
         suma_prijmutiH1_n_matlab = 0; %inicializace
         
         suma_prijmutiH1_1_upper = 0; %inicializace
         suma_prijmutiH1_n_upper = 0; %inicializace
         suma_prijmutiH1_1_matlab_upper = 0; %inicializace
         suma_prijmutiH1_n_matlab_upper = 0; %inicializace
         
            for i = 1:pocet_simulaci
               norm_data = normrnd(mu,sigma,[1,NN(j)]); %data ridici se norm.r (pocet hodnot je promenlivy)
               maximum = max(norm_data);
               minimum = min(nonzeros(norm_data));
                 for outl = 1:(outliers(o)) % 1:1, 1:2, 1:5, 1:10        
            upper_outliers(1,outl) =  maximum+4*sigma + rand*sigma; %generovani upper outliers pro dan pocty
                    end
      lower_outlier = minimum-4*sigma - rand*sigma; %1 lower outlier
      data_obsahujici_outliers_upper = [norm_data upper_outliers]; %jen upper outliers
      data_obsahujici_outliers = [norm_data upper_outliers lower_outlier];
%clear upper_outliers; clear lower_outlier; %aby se v i-t iteraci tvorila nova outliers
n = nnz(data_obsahujici_outliers); %=pocet dat celkem = N+ outliers
nn = nnz(data_obsahujici_outliers_upper); %=pocet dat celkem = N+ outliers

clear upper_outliers; clear lower_outlier; %aby se v i-t iteraci tvorila nova outliers

prumer = mean(nonzeros(data_obsahujici_outliers));
s = std(nonzeros(data_obsahujici_outliers));

prumer_upper = mean(nonzeros(data_obsahujici_outliers_upper));
s_upper = std(nonzeros(data_obsahujici_outliers_upper));

%pocitani grubbsova testu - udelat jako fci - Grubbstest(data)
T1 = (prumer - min(nonzeros(data_obsahujici_outliers)))/s;
Tn = (max(nonzeros(data_obsahujici_outliers))-prumer)/s;
T_alfa = (n-1)/sqrt(n)*sqrt(((tinv(alfa/n,n-2)^2))/(n-2+(tinv(alfa/n,n-2)^2)));%vychazi viz tabulky kritickych hodnot Barnett, str 298 pro 5%

T1_upper = (prumer_upper - min(nonzeros(data_obsahujici_outliers_upper)))/s_upper;
Tn_upper = (max(nonzeros(data_obsahujici_outliers_upper))-prumer_upper)/s_upper;
T_alfa_upper = (nn-1)/sqrt(nn)*sqrt(((tinv(alfa/nn,nn-2)^2))/(nn-2+(tinv(alfa/nn,nn-2)^2))); 


grubbs_test_matlab = (isoutlier(sort(data_obsahujici_outliers), 'grubbs'));
suma_prijmutiH1_1_matlab=suma_prijmutiH1_1_matlab+grubbs_test_matlab(1,1); %x1 je outlier
suma_prijmutiH1_n_matlab=suma_prijmutiH1_n_matlab+grubbs_test_matlab(1,n); %xn je outlier

grubbs_test_matlab_upper = (isoutlier(sort(data_obsahujici_outliers_upper), 'grubbs'));
suma_prijmutiH1_1_matlab_upper=suma_prijmutiH1_1_matlab_upper+grubbs_test_matlab_upper(1,1); %x1 je outlier
suma_prijmutiH1_n_matlab_upper=suma_prijmutiH1_n_matlab_upper+grubbs_test_matlab_upper(1,nn); %xn je outlier

if( T1>T_alfa)  
    suma_prijmutiH1_1=suma_prijmutiH1_1+1;
end
if( Tn>T_alfa)  
suma_prijmutiH1_n=suma_prijmutiH1_n+1;
end

if( T1_upper>T_alfa_upper)  
    suma_prijmutiH1_1_upper=suma_prijmutiH1_1_upper+1;
end
if( Tn_upper>T_alfa_upper)  
suma_prijmutiH1_n_upper=suma_prijmutiH1_n_upper+1;
end
        end
           
Grubbs_procentni_vysledek_x1(j,o) = suma_prijmutiH1_1/pocet_simulaci;
Grubbs_procentni_vysledek_xn(j,o)= suma_prijmutiH1_n/pocet_simulaci;
clear suma_prijmutiH1_n, clear suma_prijmutiH1_1;
Grubbs_Matlab_procentni_vysledek_x1(j,o)= suma_prijmutiH1_1_matlab/pocet_simulaci;
Grubbs_Matlab_procentni_vysledek_xn(j,o)= suma_prijmutiH1_n_matlab/pocet_simulaci;
clear suma_prijmutiH1_1_matlab; clear suma_prijmutiH1_n_matlab;

Grubbs_procentni_vysledek_x1_upper(j,o) = suma_prijmutiH1_1_upper/pocet_simulaci;
Grubbs_procentni_vysledek_xn_upper(j,o)= suma_prijmutiH1_n_upper/pocet_simulaci;
clear suma_prijmutiH1_n_upper, clear suma_prijmutiH1_1_upper;
Grubbs_Matlab_procentni_vysledek_x1_upper(j,o)= suma_prijmutiH1_1_matlab_upper/pocet_simulaci;
Grubbs_Matlab_procentni_vysledek_xn_upper(j,o)= suma_prijmutiH1_n_matlab_upper/pocet_simulaci;
clear suma_prijmutiH1_1_matlab_upper; clear suma_prijmutiH1_n_matlab_upper;
    end
end
   
fig = figure(1);
for i = 1: rozmer_outliers
plot((outliers(i)+2):pocet_dat,Grubbs_procentni_vysledek_x1((outliers(i)+2):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+2):pocet_dat, Grubbs_Matlab_procentni_vysledek_x1((outliers(i)+2):pocet_dat,i),'-.','LineWidth',1.5);
hold on;
end
title("spnost Grubbsova testu pro detekci outliera x1 v 1. verzi dat");
legend('2 outliers','2 outliers (Matlab)','3 outliers','3 outliers (Matlab)','6 outliers','6 outliers (Matlab)','11 outliers','11 outliers (Matlab)', 'Location','southeast');
xlabel('Poet dat dch se normlnm rozdlenm N');
ylabel('spnost testu');
ylim([0 1.1]);
hold off;

fig = figure(2);
for i = 1: rozmer_outliers
plot((outliers(i)+2):pocet_dat,Grubbs_procentni_vysledek_xn((outliers(i)+2):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+2):pocet_dat,Grubbs_Matlab_procentni_vysledek_xn((outliers(i)+2):pocet_dat,i),'-.','LineWidth',1.5);
hold on;
end
title("spnost Grubbsova testu pro detekci outliera xn v 1. verzi dat");
legend('2 outliers','2 outliers (Matlab)','3 outliers','3 outliers (Matlab)','6 outliers','6 outliers (Matlab)','11 outliers','11 outliers (Matlab)','Location','southeast');
xlabel('Poet dat dch se normlnm rozdlenm N');
ylabel('spnost testu');
ylim([0 1.1]);
hold off;

% fig = figure(3);
% for i = 1: rozmer_outliers
% plot((outliers(i)+1):pocet_dat,Grubbs_procentni_vysledek_x1_upper((outliers(i)+1):pocet_dat,i),'LineWidth',1.5);
% hold on;
% plot((outliers(i)+1):pocet_dat, Grubbs_Matlab_procentni_vysledek_x1_upper((outliers(i)+1):pocet_dat,i),'-.','LineWidth',1.5);
% hold on;
% end
% title("spnost Grubbsova testu pro detekci outliera x1 ve 2. verzi dat");
% legend('1 outlier','1 outlier (Matlab)','2 outliers','2 outliers (Matlab)','5 outliers', '5 outliers (Matlab)','10 outliers','10 outliers (Matlab)');
% xlabel('Poet dat dch se normlnm rozdlenm n');
%hold off;

fig = figure(3);
for i = 1: rozmer_outliers
plot((outliers(i)+1):pocet_dat,Grubbs_procentni_vysledek_xn_upper((outliers(i)+1):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+1):pocet_dat,Grubbs_Matlab_procentni_vysledek_xn_upper((outliers(i)+1):pocet_dat,i),'-.','LineWidth',1.5);
hold on;
end
title("spnost Grubbsova testu pro detekci outliera xn ve 2. verzi dat");
legend('1 outliers','1 outliers (Matlab)','2 outliers','2 outliers (Matlab)','5 outliers','5 outliers (Matlab)','10 outliers','10 outliers (Matlab)','Location','southeast');
xlabel('Poet dat dch se normlnm rozdlenm N');
ylabel('spnost testu');
ylim([0 1.1]);
hold off;

vysledky = zeros(4,4);
vysledky_upper = zeros(2,4);
for i = 1 :rozmer_outliers
    vysledky(1,i) = find(Grubbs_procentni_vysledek_x1((outliers(i)+2):pocet_dat,i) == 1, 1, 'first');
    vysledky(2,i) = find(Grubbs_Matlab_procentni_vysledek_x1((outliers(i)+2):pocet_dat,i) == 1, 1, 'first');
    vysledky(3,i) = find(Grubbs_procentni_vysledek_xn((outliers(i)+2):pocet_dat,i) == 1, 1, 'first');
    vysledky(4,i) = find(Grubbs_Matlab_procentni_vysledek_xn((outliers(i)+2):pocet_dat,i) == 1, 1, 'first');
    
end

    for i  = 1:rozmer_outliers
   %vysledky(5,i) = find(Grubbs_procentni_vysledek_x1_upper(:,i) == 1, 1, 'first');
    %vysledky(6,i) = find(Grubbs_Matlab_procentni_vysledek_x1_upper(:,i) == 1, 1, 'first');
    vysledky_upper(1,i) = find(Grubbs_procentni_vysledek_xn_upper((outliers(i)+1):pocet_dat,i) == 1, 1, 'first');
    vysledky_upper(2,i) = find(Grubbs_Matlab_procentni_vysledek_xn_upper((outliers(i)+1):pocet_dat,i) == 1, 1, 'first');
    end
    
vysledek = array2table(vysledky, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'Grubbsv test pro detekci outliera x1','Grubbsv test (Matlab) pro detekci outliera x1','Grubbsv test pro detekci outliera xn','Grubbsv test (Matlab) pro detekci outliera xn'});
vysledek1 = table(vysledek,'VariableNames',{'Poet dat N, kdy je 100% spnost detekce outlier v 1. datech'});
display(vysledek1)

vysledek_upper = array2table(vysledky_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'Grubbsv test pro detekci outliera xn','Grubbsv test (Matlab) pro detekci outliera xn'});
vysledek1_upper = table(vysledek_upper,'VariableNames',{'Poet dat N, kdy je 100% spnost detekce outlier v 2. datech'});
display(vysledek1_upper)